import joi, { ObjectSchema } from 'joi';
import { allowNullAndEmpty, caseInsensitive, documentType, gasLuceOrDual, isRequired, needDataGas, needDataPower, needIf, needIfNo, yesOrNo } from '../validatorUtils';

const needDataPowerEniResidenziale = (schema: joi.AnySchema) => needDataPower('tipoFornitura', schema);
const needDataGasEniResidenziale = (schema: joi.AnySchema) => needDataGas('tipoFornitura', schema);

export default (): ObjectSchema => joi.object({
  idDatiContratto: isRequired(joi.alternatives().try(joi.string(), joi.number())),
  tipologiaContratto: joi.string(),
  codiceAgente: isRequired(joi.string()),
  segmentoCliente: isRequired(joi.string()),
  offertaPartnershipFastweb: isRequired(yesOrNo()),
  canale: isRequired(joi.string()),
  decorrenzaImmediata: isRequired(joi.boolean()),
  tipoFornitura: isRequired(gasLuceOrDual()),
  nome: isRequired(joi.string()),
  cognome: isRequired(joi.string()),
  codiceFiscale: isRequired(joi.string()),
  pod: needDataPowerEniResidenziale(joi.string()),
  pdr: needDataGasEniResidenziale(joi.string()),
  attivazioneToponimo: isRequired(joi.string()),
  attivazioneIndirizzo: isRequired(joi.string()),
  attivazioneCivico: isRequired(joi.string()),
  attivazioneProvincia: isRequired(joi.string()),
  attivazioneComune: isRequired(joi.string()),
  attivazioneCap: isRequired(joi.string()),
  attivazioneScala: allowNullAndEmpty(joi.string()),
  metodoPagamento: isRequired(joi.string().valid('bollettino', 'domiciliazione')),
  tipologiaUso: allowNullAndEmpty(joi.string().valid('abitazione', 'pertinenza')),
  offerta: isRequired(joi.string()),
  documentoNumero: isRequired(joi.string()),
  documentoTipo: isRequired(documentType()),
  documentoDataEmissione: isRequired(joi.string()),
  cellulare: isRequired(joi.string()),
  email: isRequired(joi.string()),
  indirizzoFornituraCorrispondeIndirizzoAbitazioneResidenza: isRequired(yesOrNo()),
  residenzaToponimo: needIfNo('indirizzoFornituraCorrispondeIndirizzoAbitazioneResidenza', joi.string()),
  residenzaIndirizzo: needIfNo('indirizzoFornituraCorrispondeIndirizzoAbitazioneResidenza', joi.string()),
  residenzaCivico: needIfNo('indirizzoFornituraCorrispondeIndirizzoAbitazioneResidenza', joi.string()),
  residenzaProvincia: needIfNo('indirizzoFornituraCorrispondeIndirizzoAbitazioneResidenza', joi.string()),
  residenzaComune: needIfNo('indirizzoFornituraCorrispondeIndirizzoAbitazioneResidenza', joi.string()),
  residenzaCap: needIfNo('indirizzoFornituraCorrispondeIndirizzoAbitazioneResidenza', joi.string()),
  residenzaScala: needIfNo('indirizzoFornituraCorrispondeIndirizzoAbitazioneResidenza', allowNullAndEmpty(joi.string())),
  esazioneCorrisponde: isRequired(joi.string().valid("all'indirizzo di fornitura", "all'indirizzo di residenza", 'ad un altro indirizzo')),
  esazioneToponimo: needIf('esazioneCorrisponde', 'ad un altro indirizzo', joi.string()),
  esazioneIndirizzo: needIf('esazioneCorrisponde', 'ad un altro indirizzo', joi.string()),
  esazioneCivico: needIf('esazioneCorrisponde', 'ad un altro indirizzo', joi.string()),
  esazioneProvincia: needIf('esazioneCorrisponde', 'ad un altro indirizzo', joi.string()),
  esazioneComune: needIf('esazioneCorrisponde', 'ad un altro indirizzo', joi.string()),
  esazioneCap: needIf('esazioneCorrisponde', 'ad un altro indirizzo', joi.string()),
  esazioneScala: needIf('esazioneCorrisponde', 'ad un altro indirizzo', allowNullAndEmpty(joi.string())),
  indirizzoInterlocutore: isRequired(joi.string().valid('indirizzo di residenza', 'indirizzo di fornitura', 'indirizzo di esazione', 'altro indirizzo')),
  attualeFornitoreEnergia: needDataPowerEniResidenziale(joi.string()),
  potenzaImpegnata: needDataPowerEniResidenziale(joi.string().valid('0.5', '1', '1.5', '2', '2.5', '3', '3.5', '4', '4.5', '5', '5.5', '6', '7', '8', '9', '10', '15', '20', '25', '30')),
  potenzaDisponibile: needDataPowerEniResidenziale(joi.string()),
  consumoAnnuoElettricita: needDataPowerEniResidenziale(joi.string()),
  attualeFornitoreGas: needDataGasEniResidenziale(joi.string()),
  utilizzoGas: needDataGasEniResidenziale(joi.array().items(joi.string().valid('cottura', 'acqua calda', 'riscaldamento'))),
  consumoAnnuoGas: needDataGasEniResidenziale(joi.string()),
  tipologiaAbitazione: isRequired(joi.string()),
  titolaritaFornitura: isRequired(caseInsensitive(joi.string().valid('Proprietario', 'Conduttore', 'Detentore ad altro titolo (ad es. comodato)'))),
  modalitaSpedizioneBolletta: isRequired(joi.string().valid('posta sintetica', 'digitale')),
  iban: needIf('metodoPagamento', 'domiciliazione', joi.string()),
  eniWebbolletta: isRequired(joi.boolean()),
  extraCommodity: isRequired(yesOrNo()),
  consensoPromoEni: isRequired(yesOrNo()),
  consensoAnalisiMercato: isRequired(yesOrNo()),
  consensoPromoNonEni: isRequired(yesOrNo()),
  intestatarioContoNome: needIf('metodoPagamento', 'domiciliazione', joi.string()),
  intestatarioContoCognome: needIf('metodoPagamento', 'domiciliazione', joi.string()),
  intestatarioContoCodiceFiscale: needIf('metodoPagamento', 'domiciliazione', joi.string()),
});
